//
// Module: Poscorr3xmm
// Author: Richard Saxton 
//
// Description: Main class for calculating  a source fluxer profile
//
// Modifications: See ChangeLog
//

#ifndef Poscorr3xmm_H
#define Poscorr3xmm_H

/* General classes */
#include <iostream>

/* SAS-specific classes */
#include "Tracer.h"
#include "Dal.h"
#include "CoordPair.h"

/****************************************************
 *
 * class Poscorr3xmm
 *
 ***************************************************/

class Poscorr3xmm
{
public:

  /* Constructor */
  Poscorr3xmm();

  /* Destructor */
  ~Poscorr3xmm();

  /* Member fields */
  /* Methods */

  CoordPair calcnewpos(double ra_pnt, double dec_pnt, 
     double ra, double dec, double theta_ratio);

  CoordPair calcnewpos(double ra, double dec, double theta_offset);

  //vector<double> cona2v(double ra, double dec);
   
  double thetaOffset(double thetaRad);

  // Conversion routines
  vector<vector<double> > congen(vector<double> vz, vector<double> vx);
  vector<double> convcp(vector<double> va, vector<double> vb);
  vector<vector<double> > conmin(vector<vector<double> > m_in);
  vector<double> cona2v(double ra, double dec);
  vector<double> rotvec(vector<double> v, vector<vector<double> > m);

};

#endif

